// Uebung 8 zum Fach Betriebssysteme, Child2-Programm
// Copyright Matthias Jauernig, 03IN
#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdbool.h>
#include <time.h>

bool ready1;

void sigusr1fkt(int signr){
	printf("Child2 -> Child1 bereit...\n");
	ready1=true;
}

int main(int argc, char** argv){
	pid_t pid1;
	int signr;
	struct timespec dauer;
	ready1=false;
	
	dauer.tv_sec  = 0;
	dauer.tv_nsec = 100000000;
	
	sighold(SIGUSR1);

	if(argc>1){
		pid1=(pid_t)atoi(argv[1]);
		if(pid1==0){
			printf("Child2 -> Keine korrekte Child1-PID uebergeben...\n");
			exit(1);
		}
	}
	else{
		printf("Child2 -> Keine Child1-PID uebergeben...\n");
		exit(1);
	}
	
	// unter Solaris
	sigset(SIGUSR1, sigusr1fkt);

	if(kill(getppid(),SIGUSR2) < 0)
		perror("Child2 -> Signal senden an Parent");
	
	sigrelse(SIGUSR1);
	while(!ready1);
	
	printf("Child2 -> Meine PID:  %d\n",(int)getpid());
	printf("Child2 -> Parent-PID: %d\n\n",(int)getppid());
	do{
		printf("Child2 -> Zu sendendes Signal an Child1 (0=Ende): ");
		scanf("%d",&signr);
		if(signr!=0 && signr!=SIGQUIT){
			if(kill(pid1,signr) < 0)
			    signr=0;
		}else
			kill(pid1,SIGQUIT);
		nanosleep(&dauer,NULL);
	}while(signr!=0 && signr!=SIGQUIT);
	
	exit(0);
}
